Subject: Re: bug#61846: Shell pathnames incorrectly handled, mostly due to hash characters

From: John Cummings <[email-masked]>
Date: Thu, 02 Mar 2023 15:55:38 +0000

I want to make sure I don't drift too far, so here's my current map of
the situation:

One of the issues I reported originally has been fixed. That is where
the first name in the ls output is mistakenly interpreted as the
parent of other names in the listing. As far as I can tell, this was
happening because the regex was consuming the next newline when you
just ran ls without any filename arguments, and Hyperbole was
interpreting the first name in the listing as an argument to ls. Since
that was the most common issue in my original report, I think it makes
sense to treat this bug, #61846, as tracking that exact behavior, and
I agree that it appears fixed.

The other problems that I reported originally are still occurring as
described in my original report. I'll report a bug for each
problematic behavior.

Most of the filenames in the Hyperbole distribution directory seem
pretty ordinary. I sampled a few of them and found no issues. The ones
with interesting characters like . or _ also didn't cause any
problems. But this would not negate any of the problems I originally
reported, anyway.

------- Original Message -------
On Wednesday, March 1st, 2023 at 7:59 PM, Robert Weiner <[email-masked]> wrote:

> John if you could do an ls in the Hyperbole distribution directory and summarize what happens when you use {M-RET} on specific filenames, that would help us evaluate the issue. Thanks.
>
> On Wed, Mar 1, 2023 at 6:59 AM John Cummings <[email-masked]> wrote:
>
>> Thanks Bob, looks like the problem of interpreting files as children
>> of '#buttons-9.txt#' is fixed. But most/all of the other problems
>> are still there. Are you still looking at those and/or do you want me
>> to create a bug for each problem type?
>>
>> ------- Original Message -------
>> On Tuesday, February 28th, 2023 at 10:57 PM, Robert Weiner <[email-masked]> wrote:
>>
>>>
>>>
>>> Hi John:
>>>
>>> This issue has been resolved in the latest pre-release of Hyperbole
>>> available from the elpa-devel package archive. Thanks for reporting
>>> it. -- rsw
>>>
>>>
>>> John Cummings [email-masked] writes:
>>>
>>> > I use: Editor: GNU Emacs 28.2
>>> > Hyperbole: 9.0.0
>>> > Sys Type: x86_64-pc-linux-gnu
>>> > OS Type: gnu/linux
>>> > Window Sys: None
>>> > News Reader: Gnus v5.13
>>> > Install: elpa-devel, 8.0.1pre0.20230220.191327
>>> >
>>> > Background:
>>> >
>>> > This is usage of the Hyperbole action key on implicit buttons in a
>>> > shell buffer directory listing (bash/ls). Some file or directory names
>>> > appear to have unexpected results.
>>> >
>>> > Expected Behavior (General):
>>> >
>>> > Each file or directory in the listing will be interpreted as a
>>> > pathname implicit button (regardless of whether the name could also
>>> > match some other implicit button type in another context), and using
>>> > the action key on it will visit that file or directory. This will also
>>> > be reflected in the hkey-help output.
>>> >
>>> > Actual Behavior (General):
>>> >
>>> > Certain characters or patterns in names, and/or positioning of the
>>> > names in the listing, cause the names to be interpreted
>>> > incorrectly. Some names are interpreted incorrectly due to patterns in
>>> > their own name, and some due to patterns in other names in the
>>> > listing. That is, Hyperbole seems to be interpreting several names in
>>> > the listing as one composite name.
>>> >
>>> > This can cause the Hyperbole action key to perform the wrong action,
>>> > like visitng the wrong file or directory, or not acting at all.